package main

/*
	this parses the command line arguements
	this enables command line options from other packages like 'gui' and 'log'
*/

import (
	"go.wit.com/dev/alexflint/arg"
	"go.wit.com/lib/debugger"
	"go.wit.com/lib/gui/logsettings"
	"go.wit.com/log"
)

var argv args

type args struct {
	DryRun   bool `arg:"--dry-run"          help:"only show what might be done"`
	ListPkgs bool `arg:"--list"             help:"list all the repos found in go src & forge config"`
	Force    bool `arg:"--force"            help:"build each repo"`
}

func init() {
	arg.MustParse(&argv)

	if debugger.ArgDebug() {
		log.Info("cmd line --debugger == true")
		go func() {
			log.Sleep(2)
			debugger.DebugWindow()
		}()
	}
	if debugger.ArgLogger() {
		log.Info("cmd line --loggger == true")
		go func() {
			log.Sleep(4)
			logsettings.LogWindow()
			logsettings.LogWindow()
		}()
	}
}

func (args) Version() string {
	return "testGui " + VERSION + "    Built on " + BUILDTIME
}
