package main

import (
	"os"
	"time"

	"go.wit.com/gui"
	"go.wit.com/log"
)

// sent via -ldflags
var VERSION string
var BUILDTIME string

func main() {
	me = new(autoType)
	// setup the GUI
	me.myGui = gui.New()

	testLoad("nocui")
	testLoad("gocui")
	testLoad("andlabs")
	testLoad("pixelgl")
	testLoad("fyne")
	//testLoad("fail")
}

func testLoad(name string) {
	if _, err := me.myGui.LoadToolkit(name); err == nil {
	} else {
		log.Warn("LoadToolkit() failed to load", name, "error:", err)
		os.Exit(-1)
	}
	time.Sleep(3 * time.Second)
	me.myGui.CloseToolkit(name)
}
